<template>
  <b-container fluid>
    <b-card :header="caption">
      <div slot="header">
        Поставщики
        <div class="card-header-actions">
          <button :disabled="isDisabled()" class="btn btn-primary btn-sm" @click="openAddingModal">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>
      <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" @filtered="onFiltered" :filter="filter" responsive :items="items" :fields="fields" :current-page="currentPage" :per-page="perPage">
        <template slot="active" slot-scope="data">
          {{ data.item.active ? 'Активный' : 'Не активный' }}
        </template>
        <template slot="action" slot-scope="data">
          <b-button size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn" :disabled="isDisabled()">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination :total-rows="items.length" :per-page="perPage" v-model="currentPage" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
      </nav>
    </b-card>

    <b-modal id="modalInfo" @hide="resetModal" title="Редактирование поставщика" centered @ok="edit" ok-only>
      <h6>Поставщик: {{modalInfo.name}} {{modalInfo.lastName}}</h6>
      <b-container fluid>
        <b-form-group>
          <label>Имя</label>
          <input type="text" class="form-control" name="name2" :placeholder="modalInfo.name" v-model="modalInfo.name" v-validate="'required'"></input>
          <span v-show="errors.has('name2')" class="text-danger">{{ errors.first('name2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Фамилия</label>
          <input type="text" class="form-control" name="lastName2" :placeholder="modalInfo.lastName" v-model="modalInfo.lastName" v-validate="'required'"></input>
          <span v-show="errors.has('lastName2')" class="text-danger">{{ errors.first('lastName2') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Телефон</label>
          <masked-input v-model="modalInfo.phone" class="form-control" mask="\8 (111) 111-11-11" placeholder="Телефон" name="phone2"></masked-input>
        </b-form-group>
        <b-form-group>
          <label>Статус</label>
          <b-form-select v-model="modalInfo.active" :options="active"></b-form-select>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="edit">Изменить</b-btn>
        <!-- <b-btn class="mt-3" variant="outline-danger" block @click="deleting(modalInfo._id)">Удалить</b-btn> -->
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
    <b-modal id="addingModal" @hide="resetModal" title="Добавление поставщика" centered @ok="adding" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Имя</label>
          <input type="text" class="form-control" name="name" placeholder="Имя" v-model="addedUser.name" v-validate="'required'"></input>
          <span v-show="errors.has('name')" class="text-danger">{{ errors.first('name') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Фамилия</label>
          <input type="text" class="form-control" name="lastName" placeholder="Фамилия" v-model="addedUser.lastName" v-validate="'required'"></input>
          <span v-show="errors.has('lastName')" class="text-danger">{{ errors.first('lastName') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Телефон</label>
          <masked-input name="phone" class="form-control" mask="\8 (111) 111-11-11" placeholder="Телефон" v-model="addedUser.phone"></masked-input>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import Api from '@/services/Api'
import MaskedInput from 'vue-masked-input'

export default {
  components: {
      MaskedInput
  },
  name: 'Suppliers',
  props: {
    caption: {
      type: String,
      default: 'Сотрудники'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      userLevel: localStorage.getItem('level'),
      items: [],
      cities: [],
      active: [
        { value: true, text: 'Активный'},
        { value: false, text: 'Не активный'}
      ],
      fields: [
        { key: 'name', sortable: true, label: 'Имя' },
        { key: 'lastName', sortable: true, label: 'Фамилия' },
        { key: 'phone', sortable: true, label: 'Телефон' },
        { key: 'active', sortable: true, label: 'Статус' },
        { key: 'action', label: 'Действия' }
      ],
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      rowCount: 1,
      filter: null,
      modalInfo: {
        id: '',
        name: '',
        lastName: '',
        position: '',
        department: '',
        phone: '',
        status: '',
        active: ''
      },
      addedUser: {
        name: '',
        lastName: '',
        position: '',
        department: '',
        phone: '',
        city: '',
        type: 'supplier',
        status: 'active'
      }
    }
  },
  beforeMount () {
    this.getCities()
    this.getUsers()
  },
  computed: {
    disabled () {
      if (this.addedUser.name.length > 0 && this.addedUser.lastName.length > 0) {
        return false
      } else {
        return true
      }
    },
    disabledEdit () {
      if (this.modalInfo.name.length > 0 && this.modalInfo.lastName.length > 0) {
        return false
      } else {
        return true
      }
    }
  },
  methods: {
    isDisabled() {
      return this.userLevel === "2"
    },
    getCities () {
      Api().get('getCities').then(response => {
        this.cities = response.data.map(item => {
          return {
            value: item.name,
            text: item.name
          }
        })
      })
    },
    getUsers () {
      Api().post('getByParameters', {type: 'provider'}).then(response => {
        this.items = response.data
      })
    },
    adding () {
      this.$validator.validateAll()
      if (this.validateAdding()) {
        this.addedUser.type = 'provider'
        this.addedUser.phone = this.addedUser.phone.replace(/\D+/g, "")
        Api().post('adduser', this.addedUser).then(response => {
          if (response.data.code === 11000) {
            alert('duplicate phone or email')
          } else {
            this.resetModal()
            window.location.reload()
          }
        })
      }
    },
    edit () {
      this.$validator.validateAll()
      if (this.validateEditing()) {
        this.modalInfo.phone = this.modalInfo.phone.replace(/\D+/g, "")
        Api().post('edituser', this.modalInfo).then(response => {
          this.resetModal()
          window.location.reload()
        })
      }
    },
    deleting (_id) {
      const answer = confirm('Нажмите OK для продолжения или Cancel для выхода.')
      if (answer) {
        Api().post('deletingusers', {_id}).then(response => {
          if (response.data.n && response.data.n > 0) {
            this.resetModal()
            window.location.reload()
          } else {
            alert('ne udalilsya')
          }
        })
      } else {
        this.resetModal()
      }
    },
    validateAdding () {
      if (this.addedUser.name.length > 0 && this.addedUser.lastName.length > 0) {
        return true
      } else {
        return false
      }
    },
    validateEditing () {
      if (this.modalInfo.name.length > 0 && this.modalInfo.lastName.length > 0) {
        return true
      } else {
        return false
      }
    },
    info (_item) {
      this.modalInfo = _item
      this.$root.$emit('bv::show::modal', 'modalInfo')
    },
    resetModal () {
      this.modalInfo.title = ''
      this.modalInfo.content = ''
      this.addedUser.login = ''
      this.addedUser.name = ''
      this.addedUser.lastName = ''
      this.addedUser.position = ''
      this.addedUser.department = ''
      this.addedUser.phone = ''
      this.errors.clear()
    },
    onFiltered (filteredItems) {
      this.rowCount = filteredItems.length
      this.currentPage = 1
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    }
  }
}
</script>
